# Roadmap

## Process and Tools

The OSM team uses the [Roadmap GitHub Project Board](https://github.com/orgs/openservicemesh/projects/1) to track short term (1-3 months) and medium term (3-6 months) efforts. Once a broad objective (from the "Research & Scoping" column) is further scoped into a GitHub issue that has a clear objective, background and motive, it is moved into the "Planned & Scoped" column. From there, the team plans monthly releases via [GitHub Milestones](https://github.com/openservicemesh/osm/milestones).

## Current and Future Objectives

At this time, the OSM community is working on:
- Hardening of the project with a rigorous testing environment.
- Implementing SMI Traffic Metrics and build tooling to leverage it.
- Iterating on SMI Traffic Split and Traffic Access implementations.

In the medium to long term future, the OSM community will tackle the following:
- Iterate on the current Ingress/Egress functionality, experience, workflow.
- Iterate on existing tools for debugging the OSM control plane and data plane.
- Leverage xDS v3 protocol when limited by SMI to provide a "no cliffs" design.
- Extend OSM to support VMs, hybrid and multicluster scenarios.

## Getting Involved

Please file [GitHub issues](https://github.com/openservicemesh/osm/issues) to propose features and identify bugs. See more information about how to get involved with the community [here](https://github.com/openservicemesh/osm/projects/3).
