/*
Licensed under the Apache License, Version 2.0 (the "License");
you may not use this file except in compliance with the License.
You may obtain a copy of the License at

    http://www.apache.org/licenses/LICENSE-2.0

Unless required by applicable law or agreed to in writing, software
distributed under the License is distributed on an "AS IS" BASIS,
WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
See the License for the specific language governing permissions and
limitations under the License.
*/
// Code generated by client-gen. DO NOT EDIT.

package fake

import (
	"context"

	v1alpha2 "github.com/openservicemesh/osm/pkg/apis/config/v1alpha2"
	v1 "k8s.io/apimachinery/pkg/apis/meta/v1"
	labels "k8s.io/apimachinery/pkg/labels"
	schema "k8s.io/apimachinery/pkg/runtime/schema"
	types "k8s.io/apimachinery/pkg/types"
	watch "k8s.io/apimachinery/pkg/watch"
	testing "k8s.io/client-go/testing"
)

// FakeMeshConfigs implements MeshConfigInterface
type FakeMeshConfigs struct {
	Fake *FakeConfigV1alpha2
	ns   string
}

var meshconfigsResource = schema.GroupVersionResource{Group: "config.openservicemesh.io", Version: "v1alpha2", Resource: "meshconfigs"}

var meshconfigsKind = schema.GroupVersionKind{Group: "config.openservicemesh.io", Version: "v1alpha2", Kind: "MeshConfig"}

// Get takes name of the meshConfig, and returns the corresponding meshConfig object, and an error if there is any.
func (c *FakeMeshConfigs) Get(ctx context.Context, name string, options v1.GetOptions) (result *v1alpha2.MeshConfig, err error) {
	obj, err := c.Fake.
		Invokes(testing.NewGetAction(meshconfigsResource, c.ns, name), &v1alpha2.MeshConfig{})

	if obj == nil {
		return nil, err
	}
	return obj.(*v1alpha2.MeshConfig), err
}

// List takes label and field selectors, and returns the list of MeshConfigs that match those selectors.
func (c *FakeMeshConfigs) List(ctx context.Context, opts v1.ListOptions) (result *v1alpha2.MeshConfigList, err error) {
	obj, err := c.Fake.
		Invokes(testing.NewListAction(meshconfigsResource, meshconfigsKind, c.ns, opts), &v1alpha2.MeshConfigList{})

	if obj == nil {
		return nil, err
	}

	label, _, _ := testing.ExtractFromListOptions(opts)
	if label == nil {
		label = labels.Everything()
	}
	list := &v1alpha2.MeshConfigList{ListMeta: obj.(*v1alpha2.MeshConfigList).ListMeta}
	for _, item := range obj.(*v1alpha2.MeshConfigList).Items {
		if label.Matches(labels.Set(item.Labels)) {
			list.Items = append(list.Items, item)
		}
	}
	return list, err
}

// Watch returns a watch.Interface that watches the requested meshConfigs.
func (c *FakeMeshConfigs) Watch(ctx context.Context, opts v1.ListOptions) (watch.Interface, error) {
	return c.Fake.
		InvokesWatch(testing.NewWatchAction(meshconfigsResource, c.ns, opts))

}

// Create takes the representation of a meshConfig and creates it.  Returns the server's representation of the meshConfig, and an error, if there is any.
func (c *FakeMeshConfigs) Create(ctx context.Context, meshConfig *v1alpha2.MeshConfig, opts v1.CreateOptions) (result *v1alpha2.MeshConfig, err error) {
	obj, err := c.Fake.
		Invokes(testing.NewCreateAction(meshconfigsResource, c.ns, meshConfig), &v1alpha2.MeshConfig{})

	if obj == nil {
		return nil, err
	}
	return obj.(*v1alpha2.MeshConfig), err
}

// Update takes the representation of a meshConfig and updates it. Returns the server's representation of the meshConfig, and an error, if there is any.
func (c *FakeMeshConfigs) Update(ctx context.Context, meshConfig *v1alpha2.MeshConfig, opts v1.UpdateOptions) (result *v1alpha2.MeshConfig, err error) {
	obj, err := c.Fake.
		Invokes(testing.NewUpdateAction(meshconfigsResource, c.ns, meshConfig), &v1alpha2.MeshConfig{})

	if obj == nil {
		return nil, err
	}
	return obj.(*v1alpha2.MeshConfig), err
}

// Delete takes name of the meshConfig and deletes it. Returns an error if one occurs.
func (c *FakeMeshConfigs) Delete(ctx context.Context, name string, opts v1.DeleteOptions) error {
	_, err := c.Fake.
		Invokes(testing.NewDeleteActionWithOptions(meshconfigsResource, c.ns, name, opts), &v1alpha2.MeshConfig{})

	return err
}

// DeleteCollection deletes a collection of objects.
func (c *FakeMeshConfigs) DeleteCollection(ctx context.Context, opts v1.DeleteOptions, listOpts v1.ListOptions) error {
	action := testing.NewDeleteCollectionAction(meshconfigsResource, c.ns, listOpts)

	_, err := c.Fake.Invokes(action, &v1alpha2.MeshConfigList{})
	return err
}

// Patch applies the patch and returns the patched meshConfig.
func (c *FakeMeshConfigs) Patch(ctx context.Context, name string, pt types.PatchType, data []byte, opts v1.PatchOptions, subresources ...string) (result *v1alpha2.MeshConfig, err error) {
	obj, err := c.Fake.
		Invokes(testing.NewPatchSubresourceAction(meshconfigsResource, c.ns, name, pt, data, subresources...), &v1alpha2.MeshConfig{})

	if obj == nil {
		return nil, err
	}
	return obj.(*v1alpha2.MeshConfig), err
}
