/*
Licensed under the Apache License, Version 2.0 (the "License");
you may not use this file except in compliance with the License.
You may obtain a copy of the License at

    http://www.apache.org/licenses/LICENSE-2.0

Unless required by applicable law or agreed to in writing, software
distributed under the License is distributed on an "AS IS" BASIS,
WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
See the License for the specific language governing permissions and
limitations under the License.
*/
// Code generated by client-gen. DO NOT EDIT.

package fake

import (
	"context"

	v1alpha2 "github.com/openservicemesh/osm/pkg/apis/config/v1alpha2"
	v1 "k8s.io/apimachinery/pkg/apis/meta/v1"
	labels "k8s.io/apimachinery/pkg/labels"
	schema "k8s.io/apimachinery/pkg/runtime/schema"
	types "k8s.io/apimachinery/pkg/types"
	watch "k8s.io/apimachinery/pkg/watch"
	testing "k8s.io/client-go/testing"
)

// FakeMeshRootCertificates implements MeshRootCertificateInterface
type FakeMeshRootCertificates struct {
	Fake *FakeConfigV1alpha2
	ns   string
}

var meshrootcertificatesResource = schema.GroupVersionResource{Group: "config.openservicemesh.io", Version: "v1alpha2", Resource: "meshrootcertificates"}

var meshrootcertificatesKind = schema.GroupVersionKind{Group: "config.openservicemesh.io", Version: "v1alpha2", Kind: "MeshRootCertificate"}

// Get takes name of the meshRootCertificate, and returns the corresponding meshRootCertificate object, and an error if there is any.
func (c *FakeMeshRootCertificates) Get(ctx context.Context, name string, options v1.GetOptions) (result *v1alpha2.MeshRootCertificate, err error) {
	obj, err := c.Fake.
		Invokes(testing.NewGetAction(meshrootcertificatesResource, c.ns, name), &v1alpha2.MeshRootCertificate{})

	if obj == nil {
		return nil, err
	}
	return obj.(*v1alpha2.MeshRootCertificate), err
}

// List takes label and field selectors, and returns the list of MeshRootCertificates that match those selectors.
func (c *FakeMeshRootCertificates) List(ctx context.Context, opts v1.ListOptions) (result *v1alpha2.MeshRootCertificateList, err error) {
	obj, err := c.Fake.
		Invokes(testing.NewListAction(meshrootcertificatesResource, meshrootcertificatesKind, c.ns, opts), &v1alpha2.MeshRootCertificateList{})

	if obj == nil {
		return nil, err
	}

	label, _, _ := testing.ExtractFromListOptions(opts)
	if label == nil {
		label = labels.Everything()
	}
	list := &v1alpha2.MeshRootCertificateList{ListMeta: obj.(*v1alpha2.MeshRootCertificateList).ListMeta}
	for _, item := range obj.(*v1alpha2.MeshRootCertificateList).Items {
		if label.Matches(labels.Set(item.Labels)) {
			list.Items = append(list.Items, item)
		}
	}
	return list, err
}

// Watch returns a watch.Interface that watches the requested meshRootCertificates.
func (c *FakeMeshRootCertificates) Watch(ctx context.Context, opts v1.ListOptions) (watch.Interface, error) {
	return c.Fake.
		InvokesWatch(testing.NewWatchAction(meshrootcertificatesResource, c.ns, opts))

}

// Create takes the representation of a meshRootCertificate and creates it.  Returns the server's representation of the meshRootCertificate, and an error, if there is any.
func (c *FakeMeshRootCertificates) Create(ctx context.Context, meshRootCertificate *v1alpha2.MeshRootCertificate, opts v1.CreateOptions) (result *v1alpha2.MeshRootCertificate, err error) {
	obj, err := c.Fake.
		Invokes(testing.NewCreateAction(meshrootcertificatesResource, c.ns, meshRootCertificate), &v1alpha2.MeshRootCertificate{})

	if obj == nil {
		return nil, err
	}
	return obj.(*v1alpha2.MeshRootCertificate), err
}

// Update takes the representation of a meshRootCertificate and updates it. Returns the server's representation of the meshRootCertificate, and an error, if there is any.
func (c *FakeMeshRootCertificates) Update(ctx context.Context, meshRootCertificate *v1alpha2.MeshRootCertificate, opts v1.UpdateOptions) (result *v1alpha2.MeshRootCertificate, err error) {
	obj, err := c.Fake.
		Invokes(testing.NewUpdateAction(meshrootcertificatesResource, c.ns, meshRootCertificate), &v1alpha2.MeshRootCertificate{})

	if obj == nil {
		return nil, err
	}
	return obj.(*v1alpha2.MeshRootCertificate), err
}

// UpdateStatus was generated because the type contains a Status member.
// Add a +genclient:noStatus comment above the type to avoid generating UpdateStatus().
func (c *FakeMeshRootCertificates) UpdateStatus(ctx context.Context, meshRootCertificate *v1alpha2.MeshRootCertificate, opts v1.UpdateOptions) (*v1alpha2.MeshRootCertificate, error) {
	obj, err := c.Fake.
		Invokes(testing.NewUpdateSubresourceAction(meshrootcertificatesResource, "status", c.ns, meshRootCertificate), &v1alpha2.MeshRootCertificate{})

	if obj == nil {
		return nil, err
	}
	return obj.(*v1alpha2.MeshRootCertificate), err
}

// Delete takes name of the meshRootCertificate and deletes it. Returns an error if one occurs.
func (c *FakeMeshRootCertificates) Delete(ctx context.Context, name string, opts v1.DeleteOptions) error {
	_, err := c.Fake.
		Invokes(testing.NewDeleteActionWithOptions(meshrootcertificatesResource, c.ns, name, opts), &v1alpha2.MeshRootCertificate{})

	return err
}

// DeleteCollection deletes a collection of objects.
func (c *FakeMeshRootCertificates) DeleteCollection(ctx context.Context, opts v1.DeleteOptions, listOpts v1.ListOptions) error {
	action := testing.NewDeleteCollectionAction(meshrootcertificatesResource, c.ns, listOpts)

	_, err := c.Fake.Invokes(action, &v1alpha2.MeshRootCertificateList{})
	return err
}

// Patch applies the patch and returns the patched meshRootCertificate.
func (c *FakeMeshRootCertificates) Patch(ctx context.Context, name string, pt types.PatchType, data []byte, opts v1.PatchOptions, subresources ...string) (result *v1alpha2.MeshRootCertificate, err error) {
	obj, err := c.Fake.
		Invokes(testing.NewPatchSubresourceAction(meshrootcertificatesResource, c.ns, name, pt, data, subresources...), &v1alpha2.MeshRootCertificate{})

	if obj == nil {
		return nil, err
	}
	return obj.(*v1alpha2.MeshRootCertificate), err
}
