/*
Licensed under the Apache License, Version 2.0 (the "License");
you may not use this file except in compliance with the License.
You may obtain a copy of the License at

    http://www.apache.org/licenses/LICENSE-2.0

Unless required by applicable law or agreed to in writing, software
distributed under the License is distributed on an "AS IS" BASIS,
WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
See the License for the specific language governing permissions and
limitations under the License.
*/
// Code generated by client-gen. DO NOT EDIT.

package fake

import (
	"context"

	v1alpha1 "github.com/openservicemesh/osm/pkg/apis/policy/v1alpha1"
	v1 "k8s.io/apimachinery/pkg/apis/meta/v1"
	labels "k8s.io/apimachinery/pkg/labels"
	schema "k8s.io/apimachinery/pkg/runtime/schema"
	types "k8s.io/apimachinery/pkg/types"
	watch "k8s.io/apimachinery/pkg/watch"
	testing "k8s.io/client-go/testing"
)

// FakeIngressBackends implements IngressBackendInterface
type FakeIngressBackends struct {
	Fake *FakePolicyV1alpha1
	ns   string
}

var ingressbackendsResource = schema.GroupVersionResource{Group: "policy.openservicemesh.io", Version: "v1alpha1", Resource: "ingressbackends"}

var ingressbackendsKind = schema.GroupVersionKind{Group: "policy.openservicemesh.io", Version: "v1alpha1", Kind: "IngressBackend"}

// Get takes name of the ingressBackend, and returns the corresponding ingressBackend object, and an error if there is any.
func (c *FakeIngressBackends) Get(ctx context.Context, name string, options v1.GetOptions) (result *v1alpha1.IngressBackend, err error) {
	obj, err := c.Fake.
		Invokes(testing.NewGetAction(ingressbackendsResource, c.ns, name), &v1alpha1.IngressBackend{})

	if obj == nil {
		return nil, err
	}
	return obj.(*v1alpha1.IngressBackend), err
}

// List takes label and field selectors, and returns the list of IngressBackends that match those selectors.
func (c *FakeIngressBackends) List(ctx context.Context, opts v1.ListOptions) (result *v1alpha1.IngressBackendList, err error) {
	obj, err := c.Fake.
		Invokes(testing.NewListAction(ingressbackendsResource, ingressbackendsKind, c.ns, opts), &v1alpha1.IngressBackendList{})

	if obj == nil {
		return nil, err
	}

	label, _, _ := testing.ExtractFromListOptions(opts)
	if label == nil {
		label = labels.Everything()
	}
	list := &v1alpha1.IngressBackendList{ListMeta: obj.(*v1alpha1.IngressBackendList).ListMeta}
	for _, item := range obj.(*v1alpha1.IngressBackendList).Items {
		if label.Matches(labels.Set(item.Labels)) {
			list.Items = append(list.Items, item)
		}
	}
	return list, err
}

// Watch returns a watch.Interface that watches the requested ingressBackends.
func (c *FakeIngressBackends) Watch(ctx context.Context, opts v1.ListOptions) (watch.Interface, error) {
	return c.Fake.
		InvokesWatch(testing.NewWatchAction(ingressbackendsResource, c.ns, opts))

}

// Create takes the representation of a ingressBackend and creates it.  Returns the server's representation of the ingressBackend, and an error, if there is any.
func (c *FakeIngressBackends) Create(ctx context.Context, ingressBackend *v1alpha1.IngressBackend, opts v1.CreateOptions) (result *v1alpha1.IngressBackend, err error) {
	obj, err := c.Fake.
		Invokes(testing.NewCreateAction(ingressbackendsResource, c.ns, ingressBackend), &v1alpha1.IngressBackend{})

	if obj == nil {
		return nil, err
	}
	return obj.(*v1alpha1.IngressBackend), err
}

// Update takes the representation of a ingressBackend and updates it. Returns the server's representation of the ingressBackend, and an error, if there is any.
func (c *FakeIngressBackends) Update(ctx context.Context, ingressBackend *v1alpha1.IngressBackend, opts v1.UpdateOptions) (result *v1alpha1.IngressBackend, err error) {
	obj, err := c.Fake.
		Invokes(testing.NewUpdateAction(ingressbackendsResource, c.ns, ingressBackend), &v1alpha1.IngressBackend{})

	if obj == nil {
		return nil, err
	}
	return obj.(*v1alpha1.IngressBackend), err
}

// UpdateStatus was generated because the type contains a Status member.
// Add a +genclient:noStatus comment above the type to avoid generating UpdateStatus().
func (c *FakeIngressBackends) UpdateStatus(ctx context.Context, ingressBackend *v1alpha1.IngressBackend, opts v1.UpdateOptions) (*v1alpha1.IngressBackend, error) {
	obj, err := c.Fake.
		Invokes(testing.NewUpdateSubresourceAction(ingressbackendsResource, "status", c.ns, ingressBackend), &v1alpha1.IngressBackend{})

	if obj == nil {
		return nil, err
	}
	return obj.(*v1alpha1.IngressBackend), err
}

// Delete takes name of the ingressBackend and deletes it. Returns an error if one occurs.
func (c *FakeIngressBackends) Delete(ctx context.Context, name string, opts v1.DeleteOptions) error {
	_, err := c.Fake.
		Invokes(testing.NewDeleteActionWithOptions(ingressbackendsResource, c.ns, name, opts), &v1alpha1.IngressBackend{})

	return err
}

// DeleteCollection deletes a collection of objects.
func (c *FakeIngressBackends) DeleteCollection(ctx context.Context, opts v1.DeleteOptions, listOpts v1.ListOptions) error {
	action := testing.NewDeleteCollectionAction(ingressbackendsResource, c.ns, listOpts)

	_, err := c.Fake.Invokes(action, &v1alpha1.IngressBackendList{})
	return err
}

// Patch applies the patch and returns the patched ingressBackend.
func (c *FakeIngressBackends) Patch(ctx context.Context, name string, pt types.PatchType, data []byte, opts v1.PatchOptions, subresources ...string) (result *v1alpha1.IngressBackend, err error) {
	obj, err := c.Fake.
		Invokes(testing.NewPatchSubresourceAction(ingressbackendsResource, c.ns, name, pt, data, subresources...), &v1alpha1.IngressBackend{})

	if obj == nil {
		return nil, err
	}
	return obj.(*v1alpha1.IngressBackend), err
}
