/*
Licensed under the Apache License, Version 2.0 (the "License");
you may not use this file except in compliance with the License.
You may obtain a copy of the License at

    http://www.apache.org/licenses/LICENSE-2.0

Unless required by applicable law or agreed to in writing, software
distributed under the License is distributed on an "AS IS" BASIS,
WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
See the License for the specific language governing permissions and
limitations under the License.
*/
// Code generated by client-gen. DO NOT EDIT.

package fake

import (
	"context"

	v1alpha1 "github.com/openservicemesh/osm/pkg/apis/policy/v1alpha1"
	v1 "k8s.io/apimachinery/pkg/apis/meta/v1"
	labels "k8s.io/apimachinery/pkg/labels"
	schema "k8s.io/apimachinery/pkg/runtime/schema"
	types "k8s.io/apimachinery/pkg/types"
	watch "k8s.io/apimachinery/pkg/watch"
	testing "k8s.io/client-go/testing"
)

// FakeRetries implements RetryInterface
type FakeRetries struct {
	Fake *FakePolicyV1alpha1
	ns   string
}

var retriesResource = schema.GroupVersionResource{Group: "policy.openservicemesh.io", Version: "v1alpha1", Resource: "retries"}

var retriesKind = schema.GroupVersionKind{Group: "policy.openservicemesh.io", Version: "v1alpha1", Kind: "Retry"}

// Get takes name of the retry, and returns the corresponding retry object, and an error if there is any.
func (c *FakeRetries) Get(ctx context.Context, name string, options v1.GetOptions) (result *v1alpha1.Retry, err error) {
	obj, err := c.Fake.
		Invokes(testing.NewGetAction(retriesResource, c.ns, name), &v1alpha1.Retry{})

	if obj == nil {
		return nil, err
	}
	return obj.(*v1alpha1.Retry), err
}

// List takes label and field selectors, and returns the list of Retries that match those selectors.
func (c *FakeRetries) List(ctx context.Context, opts v1.ListOptions) (result *v1alpha1.RetryList, err error) {
	obj, err := c.Fake.
		Invokes(testing.NewListAction(retriesResource, retriesKind, c.ns, opts), &v1alpha1.RetryList{})

	if obj == nil {
		return nil, err
	}

	label, _, _ := testing.ExtractFromListOptions(opts)
	if label == nil {
		label = labels.Everything()
	}
	list := &v1alpha1.RetryList{ListMeta: obj.(*v1alpha1.RetryList).ListMeta}
	for _, item := range obj.(*v1alpha1.RetryList).Items {
		if label.Matches(labels.Set(item.Labels)) {
			list.Items = append(list.Items, item)
		}
	}
	return list, err
}

// Watch returns a watch.Interface that watches the requested retries.
func (c *FakeRetries) Watch(ctx context.Context, opts v1.ListOptions) (watch.Interface, error) {
	return c.Fake.
		InvokesWatch(testing.NewWatchAction(retriesResource, c.ns, opts))

}

// Create takes the representation of a retry and creates it.  Returns the server's representation of the retry, and an error, if there is any.
func (c *FakeRetries) Create(ctx context.Context, retry *v1alpha1.Retry, opts v1.CreateOptions) (result *v1alpha1.Retry, err error) {
	obj, err := c.Fake.
		Invokes(testing.NewCreateAction(retriesResource, c.ns, retry), &v1alpha1.Retry{})

	if obj == nil {
		return nil, err
	}
	return obj.(*v1alpha1.Retry), err
}

// Update takes the representation of a retry and updates it. Returns the server's representation of the retry, and an error, if there is any.
func (c *FakeRetries) Update(ctx context.Context, retry *v1alpha1.Retry, opts v1.UpdateOptions) (result *v1alpha1.Retry, err error) {
	obj, err := c.Fake.
		Invokes(testing.NewUpdateAction(retriesResource, c.ns, retry), &v1alpha1.Retry{})

	if obj == nil {
		return nil, err
	}
	return obj.(*v1alpha1.Retry), err
}

// Delete takes name of the retry and deletes it. Returns an error if one occurs.
func (c *FakeRetries) Delete(ctx context.Context, name string, opts v1.DeleteOptions) error {
	_, err := c.Fake.
		Invokes(testing.NewDeleteActionWithOptions(retriesResource, c.ns, name, opts), &v1alpha1.Retry{})

	return err
}

// DeleteCollection deletes a collection of objects.
func (c *FakeRetries) DeleteCollection(ctx context.Context, opts v1.DeleteOptions, listOpts v1.ListOptions) error {
	action := testing.NewDeleteCollectionAction(retriesResource, c.ns, listOpts)

	_, err := c.Fake.Invokes(action, &v1alpha1.RetryList{})
	return err
}

// Patch applies the patch and returns the patched retry.
func (c *FakeRetries) Patch(ctx context.Context, name string, pt types.PatchType, data []byte, opts v1.PatchOptions, subresources ...string) (result *v1alpha1.Retry, err error) {
	obj, err := c.Fake.
		Invokes(testing.NewPatchSubresourceAction(retriesResource, c.ns, name, pt, data, subresources...), &v1alpha1.Retry{})

	if obj == nil {
		return nil, err
	}
	return obj.(*v1alpha1.Retry), err
}
