/*
Licensed under the Apache License, Version 2.0 (the "License");
you may not use this file except in compliance with the License.
You may obtain a copy of the License at

    http://www.apache.org/licenses/LICENSE-2.0

Unless required by applicable law or agreed to in writing, software
distributed under the License is distributed on an "AS IS" BASIS,
WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
See the License for the specific language governing permissions and
limitations under the License.
*/
// Code generated by client-gen. DO NOT EDIT.

package v1alpha1

import (
	"context"
	"time"

	v1alpha1 "github.com/openservicemesh/osm/pkg/apis/policy/v1alpha1"
	scheme "github.com/openservicemesh/osm/pkg/gen/client/policy/clientset/versioned/scheme"
	v1 "k8s.io/apimachinery/pkg/apis/meta/v1"
	types "k8s.io/apimachinery/pkg/types"
	watch "k8s.io/apimachinery/pkg/watch"
	rest "k8s.io/client-go/rest"
)

// UpstreamTrafficSettingsGetter has a method to return a UpstreamTrafficSettingInterface.
// A group's client should implement this interface.
type UpstreamTrafficSettingsGetter interface {
	UpstreamTrafficSettings(namespace string) UpstreamTrafficSettingInterface
}

// UpstreamTrafficSettingInterface has methods to work with UpstreamTrafficSetting resources.
type UpstreamTrafficSettingInterface interface {
	Create(ctx context.Context, upstreamTrafficSetting *v1alpha1.UpstreamTrafficSetting, opts v1.CreateOptions) (*v1alpha1.UpstreamTrafficSetting, error)
	Update(ctx context.Context, upstreamTrafficSetting *v1alpha1.UpstreamTrafficSetting, opts v1.UpdateOptions) (*v1alpha1.UpstreamTrafficSetting, error)
	UpdateStatus(ctx context.Context, upstreamTrafficSetting *v1alpha1.UpstreamTrafficSetting, opts v1.UpdateOptions) (*v1alpha1.UpstreamTrafficSetting, error)
	Delete(ctx context.Context, name string, opts v1.DeleteOptions) error
	DeleteCollection(ctx context.Context, opts v1.DeleteOptions, listOpts v1.ListOptions) error
	Get(ctx context.Context, name string, opts v1.GetOptions) (*v1alpha1.UpstreamTrafficSetting, error)
	List(ctx context.Context, opts v1.ListOptions) (*v1alpha1.UpstreamTrafficSettingList, error)
	Watch(ctx context.Context, opts v1.ListOptions) (watch.Interface, error)
	Patch(ctx context.Context, name string, pt types.PatchType, data []byte, opts v1.PatchOptions, subresources ...string) (result *v1alpha1.UpstreamTrafficSetting, err error)
	UpstreamTrafficSettingExpansion
}

// upstreamTrafficSettings implements UpstreamTrafficSettingInterface
type upstreamTrafficSettings struct {
	client rest.Interface
	ns     string
}

// newUpstreamTrafficSettings returns a UpstreamTrafficSettings
func newUpstreamTrafficSettings(c *PolicyV1alpha1Client, namespace string) *upstreamTrafficSettings {
	return &upstreamTrafficSettings{
		client: c.RESTClient(),
		ns:     namespace,
	}
}

// Get takes name of the upstreamTrafficSetting, and returns the corresponding upstreamTrafficSetting object, and an error if there is any.
func (c *upstreamTrafficSettings) Get(ctx context.Context, name string, options v1.GetOptions) (result *v1alpha1.UpstreamTrafficSetting, err error) {
	result = &v1alpha1.UpstreamTrafficSetting{}
	err = c.client.Get().
		Namespace(c.ns).
		Resource("upstreamtrafficsettings").
		Name(name).
		VersionedParams(&options, scheme.ParameterCodec).
		Do(ctx).
		Into(result)
	return
}

// List takes label and field selectors, and returns the list of UpstreamTrafficSettings that match those selectors.
func (c *upstreamTrafficSettings) List(ctx context.Context, opts v1.ListOptions) (result *v1alpha1.UpstreamTrafficSettingList, err error) {
	var timeout time.Duration
	if opts.TimeoutSeconds != nil {
		timeout = time.Duration(*opts.TimeoutSeconds) * time.Second
	}
	result = &v1alpha1.UpstreamTrafficSettingList{}
	err = c.client.Get().
		Namespace(c.ns).
		Resource("upstreamtrafficsettings").
		VersionedParams(&opts, scheme.ParameterCodec).
		Timeout(timeout).
		Do(ctx).
		Into(result)
	return
}

// Watch returns a watch.Interface that watches the requested upstreamTrafficSettings.
func (c *upstreamTrafficSettings) Watch(ctx context.Context, opts v1.ListOptions) (watch.Interface, error) {
	var timeout time.Duration
	if opts.TimeoutSeconds != nil {
		timeout = time.Duration(*opts.TimeoutSeconds) * time.Second
	}
	opts.Watch = true
	return c.client.Get().
		Namespace(c.ns).
		Resource("upstreamtrafficsettings").
		VersionedParams(&opts, scheme.ParameterCodec).
		Timeout(timeout).
		Watch(ctx)
}

// Create takes the representation of a upstreamTrafficSetting and creates it.  Returns the server's representation of the upstreamTrafficSetting, and an error, if there is any.
func (c *upstreamTrafficSettings) Create(ctx context.Context, upstreamTrafficSetting *v1alpha1.UpstreamTrafficSetting, opts v1.CreateOptions) (result *v1alpha1.UpstreamTrafficSetting, err error) {
	result = &v1alpha1.UpstreamTrafficSetting{}
	err = c.client.Post().
		Namespace(c.ns).
		Resource("upstreamtrafficsettings").
		VersionedParams(&opts, scheme.ParameterCodec).
		Body(upstreamTrafficSetting).
		Do(ctx).
		Into(result)
	return
}

// Update takes the representation of a upstreamTrafficSetting and updates it. Returns the server's representation of the upstreamTrafficSetting, and an error, if there is any.
func (c *upstreamTrafficSettings) Update(ctx context.Context, upstreamTrafficSetting *v1alpha1.UpstreamTrafficSetting, opts v1.UpdateOptions) (result *v1alpha1.UpstreamTrafficSetting, err error) {
	result = &v1alpha1.UpstreamTrafficSetting{}
	err = c.client.Put().
		Namespace(c.ns).
		Resource("upstreamtrafficsettings").
		Name(upstreamTrafficSetting.Name).
		VersionedParams(&opts, scheme.ParameterCodec).
		Body(upstreamTrafficSetting).
		Do(ctx).
		Into(result)
	return
}

// UpdateStatus was generated because the type contains a Status member.
// Add a +genclient:noStatus comment above the type to avoid generating UpdateStatus().
func (c *upstreamTrafficSettings) UpdateStatus(ctx context.Context, upstreamTrafficSetting *v1alpha1.UpstreamTrafficSetting, opts v1.UpdateOptions) (result *v1alpha1.UpstreamTrafficSetting, err error) {
	result = &v1alpha1.UpstreamTrafficSetting{}
	err = c.client.Put().
		Namespace(c.ns).
		Resource("upstreamtrafficsettings").
		Name(upstreamTrafficSetting.Name).
		SubResource("status").
		VersionedParams(&opts, scheme.ParameterCodec).
		Body(upstreamTrafficSetting).
		Do(ctx).
		Into(result)
	return
}

// Delete takes name of the upstreamTrafficSetting and deletes it. Returns an error if one occurs.
func (c *upstreamTrafficSettings) Delete(ctx context.Context, name string, opts v1.DeleteOptions) error {
	return c.client.Delete().
		Namespace(c.ns).
		Resource("upstreamtrafficsettings").
		Name(name).
		Body(&opts).
		Do(ctx).
		Error()
}

// DeleteCollection deletes a collection of objects.
func (c *upstreamTrafficSettings) DeleteCollection(ctx context.Context, opts v1.DeleteOptions, listOpts v1.ListOptions) error {
	var timeout time.Duration
	if listOpts.TimeoutSeconds != nil {
		timeout = time.Duration(*listOpts.TimeoutSeconds) * time.Second
	}
	return c.client.Delete().
		Namespace(c.ns).
		Resource("upstreamtrafficsettings").
		VersionedParams(&listOpts, scheme.ParameterCodec).
		Timeout(timeout).
		Body(&opts).
		Do(ctx).
		Error()
}

// Patch applies the patch and returns the patched upstreamTrafficSetting.
func (c *upstreamTrafficSettings) Patch(ctx context.Context, name string, pt types.PatchType, data []byte, opts v1.PatchOptions, subresources ...string) (result *v1alpha1.UpstreamTrafficSetting, err error) {
	result = &v1alpha1.UpstreamTrafficSetting{}
	err = c.client.Patch(pt).
		Namespace(c.ns).
		Resource("upstreamtrafficsettings").
		Name(name).
		SubResource(subresources...).
		VersionedParams(&opts, scheme.ParameterCodec).
		Body(data).
		Do(ctx).
		Into(result)
	return
}
